package net.hires.debug
{
   import flash.display.Bitmap;
   import flash.display.BitmapData;
   import flash.display.Sprite;
   import flash.events.Event;
   import flash.events.MouseEvent;
   import flash.geom.Rectangle;
   import flash.system.System;
   import flash.text.StyleSheet;
   import flash.text.TextField;
   import flash.utils.getTimer;
   
   public class Stats extends Sprite
   {
      private var _fps_graph:uint;
      
      private var _ms:uint;
      
      private var _timer:uint;
      
      private var _graph:BitmapData;
      
      private var _text:TextField;
      
      private var _mem:Number;
      
      private var _xml:XML;
      
      private var _mem_max_graph:uint;
      
      private var _theme:Object;
      
      private var _mem_graph:uint;
      
      private var _fps:uint;
      
      private var _ms_prev:uint;
      
      private var _rectangle:Rectangle;
      
      private var _style:StyleSheet;
      
      private var _mem_max:Number;
      
      public function Stats(param1:Object = null)
      {
         _theme = {
            "bg":51,
            "fps":16776960,
            "ms":65280,
            "mem":65535,
            "memmax":16711792
         };
         super();
         if(param1)
         {
            if(param1.bg != null)
            {
               _theme.bg = param1.bg;
            }
            if(param1.fps != null)
            {
               _theme.fps = param1.fps;
            }
            if(param1.ms != null)
            {
               _theme.ms = param1.ms;
            }
            if(param1.mem != null)
            {
               _theme.mem = param1.mem;
            }
            if(param1.memmax != null)
            {
               _theme.memmax = param1.memmax;
            }
         }
         addEventListener(Event.ADDED_TO_STAGE,init,false,0,true);
      }
      
      private function hex2css(param1:int) : String
      {
         return "#" + param1.toString(16);
      }
      
      private function update(param1:Event) : void
      {
         _timer = getTimer();
         if(_timer - 1000 > _ms_prev)
         {
            _ms_prev = _timer;
            _mem = Number((System.totalMemory * 9.54e-7).toFixed(3));
            _mem_max = _mem_max > _mem ? _mem_max : _mem;
            _fps_graph = Math.min(50,_fps / stage.frameRate * 50);
            _mem_graph = Math.min(50,Math.sqrt(Math.sqrt(_mem * 5000))) - 2;
            _mem_max_graph = Math.min(50,Math.sqrt(Math.sqrt(_mem_max * 5000))) - 2;
            _graph.scroll(1,0);
            _graph.fillRect(_rectangle,_theme.bg);
            _graph.setPixel(0,_graph.height - _fps_graph,_theme.fps);
            _graph.setPixel(0,_graph.height - (_timer - _ms >> 1),_theme.ms);
            _graph.setPixel(0,_graph.height - _mem_graph,_theme.mem);
            _graph.setPixel(0,_graph.height - _mem_max_graph,_theme.memmax);
            _xml.fps = "FPS: " + _fps + " / " + stage.frameRate;
            _xml.mem = "MEM: " + _mem;
            _xml.memMax = "MAX: " + _mem_max;
            _fps = 0;
         }
         ++_fps;
         _xml.ms = "MS: " + (_timer - _ms);
         _ms = _timer;
         _text.htmlText = _xml;
      }
      
      private function init(param1:Event) : void
      {
         removeEventListener(Event.ADDED_TO_STAGE,init);
         graphics.beginFill(_theme.bg);
         graphics.drawRect(0,0,70,50);
         graphics.endFill();
         _mem_max = 0;
         _xml = <xml><fps>FPS:</fps><ms>MS:</ms><mem>MEM:</mem><memMax>MAX:</memMax></xml>;
         _style = new StyleSheet();
         _style.setStyle("xml",{
            "fontSize":"9px",
            "fontFamily":"_sans",
            "leading":"-2px"
         });
         _style.setStyle("fps",{"color":hex2css(_theme.fps)});
         _style.setStyle("ms",{"color":hex2css(_theme.ms)});
         _style.setStyle("mem",{"color":hex2css(_theme.mem)});
         _style.setStyle("memMax",{"color":hex2css(_theme.memmax)});
         _text = new TextField();
         _text.width = 70;
         _text.height = 50;
         _text.styleSheet = _style;
         _text.condenseWhite = true;
         _text.selectable = false;
         _text.mouseEnabled = false;
         addChild(_text);
         var _loc2_:Bitmap = new Bitmap(_graph = new BitmapData(70,50,false,_theme.bg));
         _loc2_.y = 50;
         addChild(_loc2_);
         _rectangle = new Rectangle(0,0,1,_graph.height);
         addEventListener(MouseEvent.CLICK,onClick);
         addEventListener(Event.ENTER_FRAME,update);
         addEventListener(Event.REMOVED_FROM_STAGE,destroy);
      }
      
      private function onClick(param1:MouseEvent) : void
      {
         if(mouseY / height > 0.5)
         {
            --stage.frameRate;
         }
         else
         {
            ++stage.frameRate;
         }
         _xml.fps = "FPS: " + _fps + " / " + stage.frameRate;
         _text.htmlText = _xml;
      }
      
      private function destroy(param1:Event) : void
      {
         removeEventListener(MouseEvent.CLICK,onClick);
         removeEventListener(Event.ENTER_FRAME,update);
         removeEventListener(Event.REMOVED_FROM_STAGE,destroy);
         _graph.dispose();
      }
   }
}

